/// <summary> /// constructor /// </summary> /// <param name="data">data related to UI</param> public BeamSystemForm(BeamSystemData data) { InitializeComponent(); m_data = data; // bound PictureBox to display the profile m_sketch = new BeamSystemSketch(previewPictureBox); }
/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public Autodesk.Revit.UI.Result Execute(ExternalCommandData commandData, ref string message, Autodesk.Revit.DB.ElementSet elements) { Transaction tran = new Transaction(commandData.Application.ActiveUIDocument.Document, "CreateBeamSystem"); tran.Start(); try { GeometryUtil.CreApp = commandData.Application.Application.Create; // initialize precondition data of the program BeamSystemData data = new BeamSystemData(commandData); // display form to collect user's setting for beam system using (BeamSystemForm form = new BeamSystemForm(data)) { if (form.ShowDialog() != DialogResult.OK) { tran.RollBack(); return(Autodesk.Revit.UI.Result.Cancelled); } } // create beam system using the parameters saved in BeamSystemData BeamSystemBuilder builder = new BeamSystemBuilder(data); builder.CreateBeamSystem(); } catch (ErrorMessageException errorEx) { // checked exception need to show in error messagebox message = errorEx.Message; tran.RollBack(); return(Autodesk.Revit.UI.Result.Failed); } catch (Exception ex) { // unchecked exception cause command failed message = "Command is failed for unexpected reason."; Trace.WriteLine(ex.ToString()); tran.RollBack(); return(Autodesk.Revit.UI.Result.Failed); } tran.Commit(); return(Autodesk.Revit.UI.Result.Succeeded); }
/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public Autodesk.Revit.UI.Result Execute(ExternalCommandData commandData, ref string message, Autodesk.Revit.DB.ElementSet elements) { Transaction tran = new Transaction(commandData.Application.ActiveUIDocument.Document, "CreateBeamSystem"); tran.Start(); try { GeometryUtil.CreApp = commandData.Application.Application.Create; // initialize precondition data of the program BeamSystemData data = new BeamSystemData(commandData); // display form to collect user's setting for beam system using (BeamSystemForm form = new BeamSystemForm(data)) { if (form.ShowDialog() != DialogResult.OK) { tran.RollBack(); return Autodesk.Revit.UI.Result.Cancelled; } } // create beam system using the parameters saved in BeamSystemData BeamSystemBuilder builder = new BeamSystemBuilder(data); builder.CreateBeamSystem(); } catch (ErrorMessageException errorEx) { // checked exception need to show in error messagebox message = errorEx.Message; tran.RollBack(); return Autodesk.Revit.UI.Result.Failed; } catch(Exception ex) { // unchecked exception cause command failed message = "Command is failed for unexpected reason."; Trace.WriteLine(ex.ToString()); tran.RollBack(); return Autodesk.Revit.UI.Result.Failed; } tran.Commit(); return Autodesk.Revit.UI.Result.Succeeded; }
/// <summary> /// constructor /// </summary> /// <param name="data">the data used to create beam system</param> public BeamSystemBuilder(BeamSystemData data) { m_data = data; }
/// <summary> /// override the base type's GetConvertHash method /// </summary> public override void GetConvertHash() { m_hash = BeamSystemData.GetBeamTypes(); }